﻿unit p11015;

{$reference p11014.dll}

interface

/// Возвращает длину линии
function ДлинаЛинии(L: TLine): real;
/// Возвращает площадь треугольника с указанными сторонами
function ПлощадьТреугольника(p: TTriangle): real;
/// Выводит координаты вершин треугольника
procedure ВыводКоординатВершин(p: TTriangle);
/// Выводит сведения о треугольнике с площадью S
procedure СведенияОТреугольнике(p: TTriangle; S: real := 0);
/// Возвращает массив n треугольников, сгенерированных случайным образом
function СгенерироватьТреугольники(n: integer): array of TTriangle;

implementation

function ДлинаЛинии(L: TLine) :=
Sqrt(Sqr(L.B.x - L.A.x) + Sqr(L.B.y - L.A.y));

function ПлощадьТреугольника(p: TTriangle): real;
begin
  var ДлинаAB := ДлинаЛинии(p.a);
  var ДлинаBC := ДлинаЛинии(p.b);
  var ДлинаAC := ДлинаЛинии(p.c);
  var Полупериметр := (ДлинаAB + ДлинаBC + ДлинаAC) / 2;
  Result := Sqrt(Полупериметр * (Полупериметр - ДлинаAB) *
      (Полупериметр - ДлинаBC) * (Полупериметр - ДлинаAC))
end;

procedure ВыводКоординатВершин(p: TTriangle);
begin
  Writeln(p.a.A, ', ', p.a.B, ', ', p.b.B)
end;

procedure СведенияОТреугольнике(p: TTriangle; S: real);
begin
  Print('Координаты вершин');
  ВыводКоординатВершин(p);
  Println('Длины сторон треугольника:',
      ДлинаЛинии(p.a), ДлинаЛинии(p.b), ДлинаЛинии(p.c));
  Print('Площадь треугольника:');
  if S = 0 then Println(ПлощадьТреугольника(p))
  else Println(S)
end;

function СгенерироватьТреугольники(n: integer): array of TTriangle;
begin
  Result := new TTriangle[n];
  for var i := 0 to n - 1 do
  begin
    var Координаты := SeqRandom(6, -100, 100)
        .Select(t -> Round(t / 10, 1)).ToArray;
    var Pa := СоздатьТочку(Координаты[0], Координаты[1]);
    var Pb := СоздатьТочку(Координаты[2], Координаты[4]);
    var Pc := СоздатьТочку(Координаты[4], Координаты[5]);
    var Lab := СоздатьЛинию(Pa, Pb);
    var Lbc := СоздатьЛинию(Pb, Pc);
    var Lac := СоздатьЛинию(Pa, Pc);
    Result[i] := СоздатьТреугольник(Lab, Lbc, Lac)
  end
end; 

end.