﻿// p13032
type
  Выпускники = class(IComparable<Выпускники>)
  
  private
    ФамилияИО: string;
    ГодВыпуска: integer;
    СрБалл: real;
  public
  
    constructor(Фам: string; Год: integer; Балл: real) :=
        (ФамилияИО, ГодВыпуска, СрБалл) := (Фам, Год, Балл);
        
    function CompareTo(Выпускник: Выпускники): integer;
    begin
      Result := Sign(Self.ГодВыпуска - Выпускник.ГодВыпуска);
      if Result = 0 then
        Result := -Sign(Self.СрБалл - Выпускник.СрБалл);
      if Result = 0 then
        if Self.ФамилияИО < Выпускник.ФамилияИО then
          Result := -1
        else
          if Self.ФамилияИО > Выпускник.ФамилияИО then
            Result := 1;
    end;
    
    property Фамилия: string read ФамилияИО; virtual;
    property Выпуск: integer read ГодВыпуска; virtual;
    property СреднийБалл: real read СрБалл; virtual;
  end;
  
begin
  var НашиВыпускники := new List<Выпускники>;
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2010, 4.27));
  НашиВыпускники.Add(new Выпускники('Петров К.В.',2012, 3.72));
  НашиВыпускники.Add(new Выпускники('Тарасова Г.А.',2010, 4.6));
  НашиВыпускники.Add(new Выпускники('Попова И.Ф.',2008, 4.47));
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2008, 4.25));
  НашиВыпускники.Add(new Выпускники('Смирнов А.И.',2010, 4.73));
  НашиВыпускники.Sorted.PrintLines;
end.