﻿type
  ДлинноеДробное = record
    ЦЧ: BigInteger;
    ДЧ: BigInteger;
    ВедущихНулей: integer;
    
    constructor(s: string);
    begin
      var ПозицияЗапятой := Pos(',', s);
      ВедущихНулей := 0;
      if ПозицияЗапятой = 0 then
      begin
        ЦЧ := BigInteger.Parse(s);
        ДЧ := BigInteger(0)
      end
      else
      begin
        ЦЧ := BigInteger.Parse(s[:ПозицияЗапятой]);
        s := s[ПозицияЗапятой + 1:];
        ДЧ := BigInteger.Parse(s);
        ВедущихНулей := ДЧ.IsZero ? 0 : s.Length - ДЧ.ToString.Length;
      end
    end;
    
    function ToString: string; override;
    begin
      Result := ЦЧ.IsZero ? '0' : ЦЧ.ToString;
      if ДЧ <> 0 then
        Result += ',' + ВедущихНулей * '0' + ДЧ.ToString
    end;
  
  end;

function СуммаЦЧ(A, B: ДлинноеДробное) := A.ЦЧ + B.ЦЧ;

function СуммаДЧ(A, B: ДлинноеДробное): ДлинноеДробное;
begin
  var Sa := A.ВедущихНулей * '0' + A.ДЧ.ToString;
  var Sb := B.ВедущихНулей * '0' + B.ДЧ.ToString;
  var (La, Lb) := (Sa.Length, Sb.Length);
  if La <> Lb then
  begin
    var Нулей := Abs(La - Lb);
    if La > Lb then
      Sb += Нулей * '0'
    else
      Sa += Нулей * '0';
    (La, Lb) := (Sa.Length, Sb.Length);  
  end;
  var Сумма := BigInteger.Parse(Sa) + BigInteger.Parse(Sb);
  var t := Сумма.ToString;
  Result.ВедущихНулей := La - t.Length; // La = Lb
  if Result.ВедущихНулей = -1 then
  begin
    Delete(t, 1, 1);
    Result.ЦЧ := BigInteger(1);
    if t.Any(c -> c <> '0') then
    begin
      Result.ДЧ := BigInteger.Parse(t);
      Result.ВедущихНулей := 0;
      while t[Result.ВедущихНулей + 1] = '0' do
        Inc(Result.ВедущихНулей)
    end
    else
    begin
      Result.ДЧ := BigInteger(0);
      Result.ВедущихНулей := 0
    end
  end
  else
  begin
    Result.ЦЧ := BigInteger(0);
    Result.ДЧ := Сумма
  end
end;

function Add(A, B: ДлинноеДробное): ДлинноеДробное;
begin
  var t := СуммаДЧ(A, B);
  Result.ЦЧ := СуммаЦЧ(A, B) + t.ЦЧ;
  Result.ДЧ := t.ДЧ;
  Result.ВедущихНулей := t.ВедущихНулей
end;

begin
  var p := new ДлинноеДробное('0,999999999');
  var q := new ДлинноеДробное('0,000000001');
  Println(Add(p, q))
end.  